DEBUG = NO

ifeq (YES, ${DEBUG})
	BIN = liberror-xmld.a
else
	BIN = liberror-xml.a
endif

VERSION = 3.4

REP_LIBRARY = ../../library/mingw$(VERSION)
REP_SOURCE = ../../source
REP_INCLUDE = ../../include
REP_EXTERNAL = ../../external/include
REP_OBJECT = ../../build/mingw$(VERSION)

CC = g++

ifeq (YES, ${DEBUG})
	OPTIMISATION = -Wall -pipe -fno-rtti -fno-exceptions -g -DDEBUG
else
	OPTIMISATION = -Wall -pipe -fno-rtti -fno-exceptions -O2 -DNDEBUG #-pedantic 
endif

DO_CC=$(CC) $(OPTIMISATION) -I$(REP_EXTERNAL) -I$(REP_INCLUDE) -c $< -o $@

OBJ = \
	$(REP_OBJECT)/command.o \
	$(REP_OBJECT)/error.o \
	$(REP_OBJECT)/log_manager.o \
	$(REP_OBJECT)/log_output.o \
	$(REP_OBJECT)/log_xml.o \
	$(REP_OBJECT)/memory.o \
	$(REP_OBJECT)/tracker.o \
	$(REP_OBJECT)/util.o

all: $(BIN) mv clean

clean:
	rm -f $(BIN)
	rm -R $(REP_OBJECT)/*
mv:
	mv $(BIN) $(REP_LIBRARY)
	
$(BIN): $(OBJ)
	ar r $(BIN) $(OBJ)
	ranlib $(BIN)

$(REP_OBJECT)/%.o: $(REP_SOURCE)/%.cpp $(REP_INCLUDE)/%.h
	$(DO_CC)
